globals
[ nest-energy
  foraging-trips-red-bees
  foraging-trips-yellow-bees
  foraging-trips-blue-bees
  foraging-trips-green-bees
  foraging-trips-pink-bees
  foraging-trips-sky-bees
  foraging-trips-cyan-bees
  foraging-trips-orange-bees
  foraging-trips-brown-bees
  foraging-trips-gray-bees
  foraging-trips-violet-bees
  foraging-trips-lime-bees
  foraging-trips-generalist-bees

  total-visits                    ;; used for foraging distance
  total-visits-red                ;; used for foraging distance
  total-visits-yellow             ;; used for foraging distance
  total-visits-blue
  total-visits-green
  total-visits-pink
  total-visits-sky
  total-visits-cyan
  total-visits-orange
  total-visits-brown
  total-visits-gray
  total-visits-violet
  total-visits-lime

  logisticA                       ;; for logistic communication function, see Railsback p. 215-216.
  logisticB                       ;; for logistic communication function
  total-patches                   ;; 30/4/2021 used for patches per trip
  total-empty-flowers             ;; 13/7/2022 used to measure how often bees find an empty flower
 ]

breed [generalist-bees generalist-bee]
breed [red-flowers red-flower]
breed [yellow-flowers yellow-flower]
breed [blue-flowers blue-flower]
breed [green-flowers green-flower]
breed [pink-flowers pink-flower]
breed [sky-flowers sky-flower]
breed [cyan-flowers cyan-flower]
breed [orange-flowers orange-flower]
breed [brown-flowers brown-flower]
breed [gray-flowers gray-flower]
breed [violet-flowers violet-flower]
breed [lime-flowers lime-flower]

breed [red-foragers red-forager]
breed [yellow-foragers yellow-forager]
breed [blue-foragers blue-forager]
breed [green-foragers green-forager]
breed [pink-foragers pink-forager]
breed [sky-foragers sky-forager]
breed [cyan-foragers cyan-forager]
breed [orange-foragers orange-forager]
breed [brown-foragers brown-forager]
breed [gray-foragers gray-forager]
breed [violet-foragers violet-forager]
breed [lime-foragers lime-forager]

breed [return-generalist-foragers return-generalist-forager]
breed [return-red-foragers return-red-forager]
breed [return-yellow-foragers return-yellow-forager]
breed [return-blue-foragers return-blue-forager]
breed [return-green-foragers return-green-forager]
breed [return-pink-foragers return-pink-forager]
breed [return-sky-foragers return-sky-forager]
breed [return-cyan-foragers return-cyan-forager]
breed [return-orange-foragers return-orange-forager]
breed [return-brown-foragers return-brown-forager]
breed [return-gray-foragers return-gray-forager]
breed [return-violet-foragers return-violet-forager]
breed [return-lime-foragers return-lime-forager]

breed [inside-nest-workers-generalist inside-nest-worker-generalist]
breed [inside-nest-workers-red inside-nest-worker-red]
breed [inside-nest-workers-yellow inside-nest-worker-yellow]
breed [inside-nest-workers-blue inside-nest-worker-blue]
breed [inside-nest-workers-green inside-nest-worker-green]
breed [inside-nest-workers-pink inside-nest-worker-pink]
breed [inside-nest-workers-sky inside-nest-worker-sky]
breed [inside-nest-workers-cyan inside-nest-worker-cyan]
breed [inside-nest-workers-orange inside-nest-worker-orange]
breed [inside-nest-workers-brown inside-nest-worker-brown]
breed [inside-nest-workers-gray inside-nest-worker-gray]
breed [inside-nest-workers-violet inside-nest-worker-violet]
breed [inside-nest-workers-lime inside-nest-worker-lime]

breed [empty-red-flowers empty-red-flower]
breed [empty-yellow-flowers empty-yellow-flower]
breed [empty-blue-flowers empty-blue-flower]
breed [empty-green-flowers empty-green-flower]
breed [empty-pink-flowers empty-pink-flower]
breed [empty-sky-flowers empty-sky-flower]
breed [empty-cyan-flowers empty-cyan-flower]
breed [empty-orange-flowers empty-orange-flower]
breed [empty-brown-flowers empty-brown-flower]
breed [empty-gray-flowers empty-gray-flower]
breed [empty-violet-flowers empty-violet-flower]
breed [empty-lime-flowers empty-lime-flower]

breed [red-influencers red-influencer]
breed [yellow-influencers yellow-influencer]          ; new 14/12/2022
breed [blue-influencers blue-influencer]          ; new 14/12/2022


breed [red-stop-foragers red-stop-forager]
breed [yellow-stop-foragers yellow-stop-forager]
breed [blue-stop-foragers blue-stop-forager]
breed [green-stop-foragers green-stop-forager]
breed [pink-stop-foragers pink-stop-forager]
breed [sky-stop-foragers sky-stop-forager]
breed [cyan-stop-foragers cyan-stop-forager]
breed [orange-stop-foragers orange-stop-forager]
breed [brown-stop-foragers brown-stop-forager]
breed [gray-stop-foragers gray-stop-forager]
breed [violet-stop-foragers violet-stop-forager]
breed [lime-stop-foragers lime-stop-forager]

breed [return-stop-foragers-generalist return-stop-forager-generalist]
breed [return-stop-foragers-red return-stop-forager-red]
breed [return-stop-foragers-yellow return-stop-forager-yellow]
breed [return-stop-foragers-blue return-stop-forager-blue]
breed [return-stop-foragers-green return-stop-forager-green]
breed [return-stop-foragers-pink return-stop-forager-pink]
breed [return-stop-foragers-sky return-stop-forager-sky]
breed [return-stop-foragers-cyan return-stop-forager-cyan]
breed [return-stop-foragers-orange return-stop-forager-orange]
breed [return-stop-foragers-brown return-stop-forager-brown]
breed [return-stop-foragers-gray return-stop-forager-gray]
breed [return-stop-foragers-violet return-stop-forager-violet]
breed [return-stop-foragers-lime return-stop-forager-lime]

turtles-own [

  forager-energy
  inside-nest-stay-time
  empty-flower-time
  flower-stay-time

  trip-generalist
  trip-red
  trip-yellow
  trip-blue
  trip-green
  trip-pink
  trip-sky
  trip-cyan
  trip-orange
  trip-brown
  trip-gray
  trip-violet
  trip-lime


  patch-distance-red
  patch-distance-yellow                        ;; 14/12/2022
  patch-distance-blue                        ;; 14/12/2022


  flower-visits                                ;;;;;;;;;;; for foraging distnace: total patch visits
  flower-visits-red
  flower-visits-yellow
  flower-visits-blue
  flower-visits-green
  flower-visits-pink
  flower-visits-sky
  flower-visits-cyan
  flower-visits-orange
  flower-visits-brown
  flower-visits-gray
  flower-visits-violet
  flower-visits-lime

  distance-red                                 ;;;;;;;;;;; for communication: distance of last visited patch
  distance-yellow                              ;;;;;;;;;;; 14/12/2022
  distance-blue                              ;;;;;;;;;;; 14/12/2022


  flight-length                                ;;;;;;;;;;; for Levy flight
  patches-visited-per-trip                     ;;; 30/4/2021 to count patches visited per trip
  empty-flowers-per-trip                       ;; 13/7/2022 to count the empty flowers visited during a trip

]

patches-own [
  nest-scent
  nest?
]

to setup
  clear-all
  ask patches [
   setup-nest
   setup-logcurve               ;;; new for log function
  ]

;;;; CREATE FLOWERS ;;;;


create-red-flowers random max-flowers-per-species [
    setxy random-xcor random-ycor
    set color red
    set shape "flower"
    set size 10
    set flower-visits 0
    set flower-visits-red 0
    set empty-flower-time flower-refilling-time
    set patch-distance-red distancexy 0 0
]


create-yellow-flowers random max-flowers-per-species [
    setxy random-xcor random-ycor
    set color yellow
    set shape "flower"
    set size 10
    set flower-visits 0
    set flower-visits-yellow 0
    set empty-flower-time flower-refilling-time
    set patch-distance-yellow distancexy 0 0                          ;; 14/12/2022

]

create-blue-flowers random max-flowers-per-species [
    setxy random-xcor random-ycor
    set color blue
    set shape "flower"
    set size 10
    set flower-visits 0
    set flower-visits-blue 0
    set empty-flower-time flower-refilling-time
    set patch-distance-blue distancexy 0 0                          ;; 14/12/2022

]

create-green-flowers random max-flowers-per-species [
    setxy random-xcor random-ycor
    set color green
    set shape "flower"
    set size 10
    set flower-visits 0
    set flower-visits-green 0
    set empty-flower-time flower-refilling-time

]

create-pink-flowers random max-flowers-per-species [
    setxy random-xcor random-ycor
    set color pink
    set shape "flower"
    set size 10
    set flower-visits 0
    set flower-visits-pink 0
    set empty-flower-time flower-refilling-time

]

create-sky-flowers random max-flowers-per-species [
    setxy random-xcor random-ycor
    set color sky
    set shape "flower"
    set size 10
    set flower-visits 0
    set flower-visits-sky 0
    set empty-flower-time flower-refilling-time

]

create-cyan-flowers random max-flowers-per-species [
    setxy random-xcor random-ycor
    set color cyan
    set shape "flower"
    set size 10
    set flower-visits 0
    set flower-visits-cyan 0
    set empty-flower-time flower-refilling-time

]

create-orange-flowers random max-flowers-per-species [
    setxy random-xcor random-ycor
    set color orange
    set shape "flower"
    set size 10
    set flower-visits 0
    set flower-visits-orange 0
    set empty-flower-time flower-refilling-time

]

create-brown-flowers random max-flowers-per-species [
    setxy random-xcor random-ycor
    set color brown
    set shape "flower"
    set size 10
    set flower-visits 0
    set flower-visits-brown 0
    set empty-flower-time flower-refilling-time

]

create-gray-flowers random max-flowers-per-species [
    setxy random-xcor random-ycor
    set color gray
    set shape "flower"
    set size 10
    set flower-visits 0
    set flower-visits-gray 0
    set empty-flower-time flower-refilling-time

]

create-violet-flowers random max-flowers-per-species [
    setxy random-xcor random-ycor
    set color violet
    set shape "flower"
    set size 10
    set flower-visits 0
    set flower-visits-violet 0
    set empty-flower-time flower-refilling-time

]

create-lime-flowers random max-flowers-per-species [
    setxy random-xcor random-ycor
    set color lime
    set shape "flower"
    set size 10
    set flower-visits 0
    set flower-visits-lime 0
    set empty-flower-time flower-refilling-time

]


  ;;;;;;;; CREATE BEES ;;;;

create-generalist-bees number-of-start-bees [
    setxy 0 0
    set size 6
    set color white
    set shape "butterfly"
    set forager-energy 0
    set flight-length 0                                          ;;;;;;;;;; for Levy flight
    set patches-visited-per-trip 0                               ;;;;;;;;;; 30/4/2021
    set empty-flowers-per-trip 0
  ]
  reset-ticks
end
                                                                 ;;;;;;;;;; CREATE NEST ;;;;
to setup-nest
  set nest? (distancexy 0 0) < 5
  set nest-scent 300 - distancexy 0 0                            ;;; 21/6/2021
  set nest-energy 0
  set total-patches 0
  set total-empty-flowers 0
  set total-visits 0
     ifelse nest?
  [ set pcolor white ]
  [ set pcolor green ]

end

;; recruitment: setup the variables for the logistic curve
to setup-logcurve
  let D ln (0.8 / (1 - 0.8))                      ; default 0.8
  let C ln (0.4 / (1 - 0.4))                      ; 0.4
  set logisticB (D - C) / (100 - 200)
  set logisticA D - (logisticB * 100)
  end




;;;; GO PROCEDURE  ;;;;

to go

;;; go procedures for flowers

ask red-flowers [
    be-eaten-red
    set color red
    set shape "flower"
    set size 10
        ]


ask yellow-flowers [
    be-eaten-yellow
    set color yellow
    set shape "flower"
    set size 10
    ]

ask blue-flowers [
    be-eaten-blue
    set color blue
    set shape "flower"
    set size 10
    ]

ask green-flowers [
    be-eaten-green
    set color green
    set shape "flower"
    set size 10
    ]

ask pink-flowers [
    be-eaten-pink
    set color pink
    set shape "flower"
    set size 10
    ]

ask sky-flowers [
    be-eaten-sky
    set color sky
    set shape "flower"
    set size 10
    ]

ask cyan-flowers [
    be-eaten-cyan
    set color cyan
    set shape "flower"
    set size 10
    ]

ask orange-flowers [
    be-eaten-orange
    set color orange
    set shape "flower"
    set size 10
    ]

ask brown-flowers [
    be-eaten-brown
    set color brown
    set shape "flower"
    set size 10
    ]

ask gray-flowers [
    be-eaten-gray
    set color gray
    set shape "flower"
    set size 10
    ]

ask violet-flowers [
    be-eaten-violet
    set color violet
    set shape "flower"
    set size 10
    ]

ask lime-flowers [
    be-eaten-lime
    set color lime
    set shape "flower"
    set size 10
    ]



ask empty-red-flowers [
    record-flower-visit
    record-flower-visit-red
    set color red
    set shape "x"
    set size 10
    set empty-flower-time empty-flower-time - 1
    if empty-flower-time < 0
    [set breed red-flowers
      set patch-distance-red distancexy 0 0
      reset-times ]]


ask empty-yellow-flowers [
    record-flower-visit
    record-flower-visit-yellow
    set color yellow
    set shape "x"
    set size 10
    set empty-flower-time empty-flower-time - 1
    if empty-flower-time < 0
    [set breed yellow-flowers
      set patch-distance-yellow distancexy 0 0
      reset-times ]]

ask empty-blue-flowers [
    record-flower-visit
    record-flower-visit-blue
    set color blue
    set shape "x"
    set size 10
    set empty-flower-time empty-flower-time - 1
    if empty-flower-time < 0
    [set breed blue-flowers

      reset-times ]]

ask empty-green-flowers [
    record-flower-visit
    record-flower-visit-green
    set color green
    set shape "x"
    set size 10
    set empty-flower-time empty-flower-time - 1
    if empty-flower-time < 0
    [set breed green-flowers

      reset-times ]]

ask empty-pink-flowers [
    record-flower-visit
    record-flower-visit-pink
    set color pink
    set shape "x"
    set size 10
    set empty-flower-time empty-flower-time - 1
    if empty-flower-time < 0
    [set breed pink-flowers

      reset-times ]]

ask empty-sky-flowers [
    record-flower-visit
    record-flower-visit-sky
    set color sky
    set shape "x"
    set size 10
    set empty-flower-time empty-flower-time - 1
    if empty-flower-time < 0
    [set breed sky-flowers

      reset-times ]]

ask empty-cyan-flowers [
    record-flower-visit
    record-flower-visit-cyan
    set color cyan
    set shape "x"
    set size 10
    set empty-flower-time empty-flower-time - 1
    if empty-flower-time < 0
    [set breed cyan-flowers

      reset-times ]]

ask empty-orange-flowers [
    record-flower-visit
    record-flower-visit-orange
    set color orange
    set shape "x"
    set size 10
    set empty-flower-time empty-flower-time - 1
    if empty-flower-time < 0
    [set breed orange-flowers

      reset-times ]]

ask empty-brown-flowers [
    record-flower-visit
    record-flower-visit-brown
    set color brown
    set shape "x"
    set size 10
    set empty-flower-time empty-flower-time - 1
    if empty-flower-time < 0
    [set breed brown-flowers

      reset-times ]]

ask empty-gray-flowers [
    record-flower-visit
    record-flower-visit-gray
    set color gray
    set shape "x"
    set size 10
    set empty-flower-time empty-flower-time - 1
    if empty-flower-time < 0
    [set breed gray-flowers

      reset-times ]]

ask empty-violet-flowers [
    record-flower-visit
    record-flower-visit-violet
    set color violet
    set shape "x"
    set size 10
    set empty-flower-time empty-flower-time - 1
    if empty-flower-time < 0
    [set breed violet-flowers

      reset-times ]]

ask empty-lime-flowers [
    record-flower-visit
    record-flower-visit-lime
    set color lime
    set shape "x"
    set size 10
    set empty-flower-time empty-flower-time - 1
    if empty-flower-time < 0
    [set breed lime-flowers

      reset-times ]]

 ;;;;; go procedures for bees

ask generalist-bees [
    set size 6
    set color white
    set shape "butterfly"
    set flower-stay-time random-normal flower-stay-timer flower-stay-timer / 5
    move-levy-flight
    eat-red-flower
    eat-yellow-flower
    eat-blue-flower
    eat-green-flower
    eat-pink-flower
    eat-sky-flower
    eat-cyan-flower
    eat-orange-flower
    eat-brown-flower
    eat-gray-flower
    eat-violet-flower
    eat-lime-flower
    find-empty-red-flower                          ;; 21/7/22 to quantify number of empty flowers encounter
    find-empty-yellow-flower                       ;; 21/7/22 to quantify number of empty flowers encounter
    find-empty-blue-flower                         ;; 21/7/22 to quantify number of empty flowers encounter
    find-empty-green-flower                        ;; 21/7/22 to quantify number of empty flowers encounter
    find-empty-pink-flower
    find-empty-sky-flower
    find-empty-cyan-flower
    find-empty-orange-flower
    find-empty-brown-flower
    find-empty-gray-flower
    find-empty-violet-flower
    find-empty-lime-flower
     if forager-energy > crop-capacity
    [set breed return-stop-foragers-generalist]
  ]

ask red-foragers [
    move-levy-flight
    eat-red-flower
    find-empty-red-flower                            ;; 21/7/22 to quantify number of empty flowers encounter
    set flower-stay-time random-normal flower-stay-timer flower-stay-timer / 5
    set size 6
    set color red
    set shape "butterfly"
    if forager-energy > crop-capacity
    [set breed return-stop-foragers-red]
  ]


ask yellow-foragers [
    move-levy-flight
    eat-yellow-flower
    find-empty-yellow-flower                            ;; 21/7/22 to quantify number of empty flowers encounter
    set flower-stay-time random-normal flower-stay-timer flower-stay-timer / 5
    set size 6
    set color yellow
    set shape "butterfly"
    if forager-energy > crop-capacity
    [set breed return-stop-foragers-yellow]
  ]

ask blue-foragers [
    move-levy-flight
    eat-blue-flower
    find-empty-blue-flower                                ;; 21/7/22 to quantify number of empty flowers encounter
    set flower-stay-time random-normal flower-stay-timer flower-stay-timer / 5
    set size 6
    set color blue
    set shape "butterfly"
    if forager-energy > crop-capacity
    [set breed return-stop-foragers-blue]
  ]

ask green-foragers [
    move-levy-flight
    eat-green-flower
    find-empty-green-flower                                   ;; 21/7/22 to quantify number of empty flowers encountere
    set flower-stay-time random-normal flower-stay-timer flower-stay-timer / 5
    set size 6
    set color green
    set shape "butterfly"
    if forager-energy > crop-capacity
    [set breed return-stop-foragers-green]
  ]

ask pink-foragers [
    move-levy-flight
    eat-pink-flower
    find-empty-pink-flower                                   ;; 21/7/22 to quantify number of empty flowers encountere
    set flower-stay-time random-normal flower-stay-timer flower-stay-timer / 5
    set size 6
    set color pink
    set shape "butterfly"
    if forager-energy > crop-capacity
    [set breed return-stop-foragers-pink]
  ]

ask sky-foragers [
    move-levy-flight
    eat-sky-flower
    find-empty-sky-flower                                   ;; 21/7/22 to quantify number of empty flowers encountere
    set flower-stay-time random-normal flower-stay-timer flower-stay-timer / 5
    set size 6
    set color sky
    set shape "butterfly"
    if forager-energy > crop-capacity
    [set breed return-stop-foragers-sky]
  ]

ask cyan-foragers [
    move-levy-flight
    eat-cyan-flower
    find-empty-cyan-flower                                   ;; 21/7/22 to quantify number of empty flowers encountere
    set flower-stay-time random-normal flower-stay-timer flower-stay-timer / 5
    set size 6
    set color cyan
    set shape "butterfly"
    if forager-energy > crop-capacity
    [set breed return-stop-foragers-cyan]
  ]

ask orange-foragers [
    move-levy-flight
    eat-orange-flower
    find-empty-orange-flower                                   ;; 21/7/22 to quantify number of empty flowers encountere
    set flower-stay-time random-normal flower-stay-timer flower-stay-timer / 5
    set size 6
    set color orange
    set shape "butterfly"
    if forager-energy > crop-capacity
    [set breed return-stop-foragers-orange]
  ]

ask brown-foragers [
    move-levy-flight
    eat-brown-flower
    find-empty-brown-flower                                   ;; 21/7/22 to quantify number of empty flowers encountere
    set flower-stay-time random-normal flower-stay-timer flower-stay-timer / 5
    set size 6
    set color brown
    set shape "butterfly"
    if forager-energy > crop-capacity
    [set breed return-stop-foragers-brown]
  ]

ask gray-foragers [
    move-levy-flight
    eat-gray-flower
    find-empty-gray-flower                                   ;; 21/7/22 to quantify number of empty flowers encountere
    set flower-stay-time random-normal flower-stay-timer flower-stay-timer / 5
    set size 6
    set color gray
    set shape "butterfly"
    if forager-energy > crop-capacity
    [set breed return-stop-foragers-gray]
  ]

ask violet-foragers [
    move-levy-flight
    eat-violet-flower
    find-empty-violet-flower                                   ;; 21/7/22 to quantify number of empty flowers encountere
    set flower-stay-time random-normal flower-stay-timer flower-stay-timer / 5
    set size 6
    set color violet
    set shape "butterfly"
    if forager-energy > crop-capacity
    [set breed return-stop-foragers-violet]
  ]

ask lime-foragers [
    move-levy-flight
    eat-lime-flower
    find-empty-lime-flower                                   ;; 21/7/22 to quantify number of empty flowers encountere
    set flower-stay-time random-normal flower-stay-timer flower-stay-timer / 5
    set size 6
    set color lime
    set shape "butterfly"
    if forager-energy > crop-capacity
    [set breed return-stop-foragers-lime]
  ]



ask red-stop-foragers [
    set color red
    set size 6
    set flower-stay-time flower-stay-time - 1
    if flower-stay-time < 0
    [ ifelse random 10000 > within-trip-constancy * 100          ;;; random 100 does occasionally lead to 0, then you get a flower constant forager for some time
     [set breed generalist-bees ]
     [set breed red-foragers ]
         ]
       ]

ask yellow-stop-foragers [
    set color yellow
    set size 6
    set flower-stay-time flower-stay-time - 1
    if flower-stay-time < 0
   [ ifelse random 10000 > within-trip-constancy * 100
     [set breed generalist-bees ]
     [set breed yellow-foragers ]
         ]
       ]

ask blue-stop-foragers [
    set color blue
    set size 6
    set flower-stay-time flower-stay-time - 1
    if flower-stay-time < 0
   [ ifelse random 10000 > within-trip-constancy * 100
     [set breed generalist-bees ]
     [set breed blue-foragers ]
         ]
       ]

ask green-stop-foragers [
    set color green
    set size 6
    set flower-stay-time flower-stay-time - 1
    if flower-stay-time < 0
   [ ifelse random 10000 > within-trip-constancy * 100
     [set breed generalist-bees ]
     [set breed green-foragers ]
         ]
       ]

ask pink-stop-foragers [
    set color pink
    set size 6
    set flower-stay-time flower-stay-time - 1
    if flower-stay-time < 0
   [ ifelse random 10000 > within-trip-constancy * 100
     [set breed generalist-bees ]
     [set breed pink-foragers ]
         ]
       ]

ask sky-stop-foragers [
    set color sky
    set size 6
    set flower-stay-time flower-stay-time - 1
    if flower-stay-time < 0
   [ ifelse random 10000 > within-trip-constancy * 100
     [set breed generalist-bees ]
     [set breed sky-foragers ]
         ]
       ]

ask cyan-stop-foragers [
    set color cyan
    set size 6
    set flower-stay-time flower-stay-time - 1
    if flower-stay-time < 0
   [ ifelse random 10000 > within-trip-constancy * 100
     [set breed generalist-bees ]
     [set breed cyan-foragers ]
         ]
       ]

ask orange-stop-foragers [
    set color orange
    set size 6
    set flower-stay-time flower-stay-time - 1
    if flower-stay-time < 0
   [ ifelse random 10000 > within-trip-constancy * 100
     [set breed generalist-bees ]
     [set breed orange-foragers ]
         ]
       ]

ask brown-stop-foragers [
    set color brown
    set size 6
    set flower-stay-time flower-stay-time - 1
    if flower-stay-time < 0
   [ ifelse random 10000 > within-trip-constancy * 100
     [set breed generalist-bees ]
     [set breed brown-foragers ]
         ]
       ]

ask gray-stop-foragers [
    set color gray
    set size 6
    set flower-stay-time flower-stay-time - 1
    if flower-stay-time < 0
   [ ifelse random 10000 > within-trip-constancy * 100
     [set breed generalist-bees ]
     [set breed gray-foragers ]
         ]
       ]

ask violet-stop-foragers [
    set color violet
    set size 6
    set flower-stay-time flower-stay-time - 1
    if flower-stay-time < 0
   [ ifelse random 10000 > within-trip-constancy * 100
     [set breed generalist-bees ]
     [set breed violet-foragers ]
         ]
       ]

ask lime-stop-foragers [
    set color lime
    set size 6
    set flower-stay-time flower-stay-time - 1
    if flower-stay-time < 0
   [ ifelse random 10000 > within-trip-constancy * 100
     [set breed generalist-bees ]
     [set breed lime-foragers ]
         ]
       ]



ask return-stop-foragers-generalist [
    set color white
    set size 6
    set flower-stay-time flower-stay-time - 1
    ;set distance-red distancexy 0 0                         ;;removed because generalists do not recruit
    if flower-stay-time < 0
    [set breed return-generalist-foragers]
  ]

ask return-stop-foragers-red [
    set color red
    set size 6
    set flower-stay-time flower-stay-time - 1
    set distance-red distancexy 0 0
    if flower-stay-time < 0
    [set breed return-red-foragers]
  ]

ask return-stop-foragers-yellow [
    set color yellow
    set size 6
    set flower-stay-time flower-stay-time - 1
    set distance-yellow distancexy 0 0                               ;; 14/12/2022
    if flower-stay-time < 0
    [set breed return-yellow-foragers]
  ]

ask return-stop-foragers-blue [
    set color blue
    set size 6
    set flower-stay-time flower-stay-time - 1
    set distance-blue distancexy 0 0                               ;; 14/12/2022
     if flower-stay-time < 0
    [set breed return-blue-foragers]
  ]

ask return-stop-foragers-green [
    set color green
    set size 6
    set flower-stay-time flower-stay-time - 1
    if flower-stay-time < 0
    [set breed return-green-foragers]
  ]

ask return-stop-foragers-pink [
    set color pink
    set size 6
    set flower-stay-time flower-stay-time - 1
    if flower-stay-time < 0
    [set breed return-pink-foragers]
  ]

ask return-stop-foragers-sky [
    set color sky
    set size 6
    set flower-stay-time flower-stay-time - 1
    if flower-stay-time < 0
    [set breed return-sky-foragers]
  ]

ask return-stop-foragers-cyan [
    set color cyan
    set size 6
    set flower-stay-time flower-stay-time - 1
     if flower-stay-time < 0
    [set breed return-cyan-foragers]
  ]

ask return-stop-foragers-orange [
    set color orange
    set size 6
    set flower-stay-time flower-stay-time - 1
    if flower-stay-time < 0
    [set breed return-orange-foragers]
  ]

ask return-stop-foragers-brown [
    set color brown
    set size 6
    set flower-stay-time flower-stay-time - 1
    if flower-stay-time < 0
    [set breed return-brown-foragers]
  ]

ask return-stop-foragers-gray [
    set color gray
    set size 6
    set flower-stay-time flower-stay-time - 1
    if flower-stay-time < 0
    [set breed return-gray-foragers]
  ]

ask return-stop-foragers-violet [
    set color violet
    set size 6
    set flower-stay-time flower-stay-time - 1
     if flower-stay-time < 0
    [set breed return-violet-foragers]
  ]

ask return-stop-foragers-lime [
    set color lime
    set size 6
    set flower-stay-time flower-stay-time - 1
    if flower-stay-time < 0
    [set breed return-lime-foragers]
  ]




ask return-generalist-foragers [
    wiggle
    move
    set size 6
    set color white
    set shape "butterfly"
    set trip-generalist 1
    set inside-nest-stay-time nest-stay-time
    return-to-nest
      if pcolor = white [
      set breed inside-nest-workers-generalist
        ]]

ask return-red-foragers [
    wiggle
    move
    set size 6
    set color red
    set shape "butterfly"
    set trip-red 1
    set inside-nest-stay-time nest-stay-time
    return-to-nest
      if pcolor = white [
      ifelse random-float recruitment-is-1 < recruitment-probability         ;; with recruitment, use 1 if not using the slider
      [ set breed red-influencers]
      [set breed inside-nest-workers-red ]]]


ask return-yellow-foragers [
    wiggle
    move
    set size 6
    set color yellow
    set shape "butterfly"
    set trip-yellow 1
    set inside-nest-stay-time nest-stay-time
    return-to-nest
      if pcolor = white [
      ifelse random-float recruitment-is-1 < recruitment-probability         ;; 14/12/2022
      [ set breed yellow-influencers]
      [set breed inside-nest-workers-yellow ]]]

ask return-blue-foragers [
    wiggle
    move
    set size 6
    set color blue
    set shape "butterfly"
    set trip-blue 1
    set inside-nest-stay-time nest-stay-time
    return-to-nest
     if pcolor = white [
     ifelse random-float recruitment-is-1 < recruitment-probability         ;; 14/12/2022
      [ set breed blue-influencers]
      [set breed inside-nest-workers-blue ]]]

ask return-green-foragers [
    wiggle
    move
    set size 6
    set color green
    set shape "butterfly"
    set trip-green 1
    set inside-nest-stay-time nest-stay-time
    return-to-nest
      if pcolor = white [set breed inside-nest-workers-green ]]

ask return-pink-foragers [
    wiggle
    move
    set size 6
    set color pink
    set shape "butterfly"
    set trip-pink 1
    set inside-nest-stay-time nest-stay-time
    return-to-nest
      if pcolor = white [     set breed inside-nest-workers-pink ]]

ask return-sky-foragers [
    wiggle
    move
    set size 6
    set color sky
    set shape "butterfly"
    set trip-sky 1
    set inside-nest-stay-time nest-stay-time
    return-to-nest
      if pcolor = white [set breed inside-nest-workers-sky ]]

ask return-cyan-foragers [
    wiggle
    move
    set size 6
    set color cyan
    set shape "butterfly"
    set trip-cyan 1
    set inside-nest-stay-time nest-stay-time
    return-to-nest
      if pcolor = white [set breed inside-nest-workers-cyan ]]

ask return-orange-foragers [
    wiggle
    move
    set size 6
    set color orange
    set shape "butterfly"
    set trip-orange 1
    set inside-nest-stay-time nest-stay-time
    return-to-nest
      if pcolor = white [set breed inside-nest-workers-orange ]]

ask return-brown-foragers [
    wiggle
    move
    set size 6
    set color brown
    set shape "butterfly"
    set trip-brown 1
    set inside-nest-stay-time nest-stay-time
    return-to-nest
      if pcolor = white [set breed inside-nest-workers-brown ]]

ask return-gray-foragers [
    wiggle
    move
    set size 6
    set color gray
    set shape "butterfly"
    set trip-gray 1
    set inside-nest-stay-time nest-stay-time
    return-to-nest
      if pcolor = white [set breed inside-nest-workers-gray ]]

ask return-violet-foragers [
    wiggle
    move
    set size 6
    set color violet
    set shape "butterfly"
    set trip-violet 1
    set inside-nest-stay-time nest-stay-time
    return-to-nest
      if pcolor = white [set breed inside-nest-workers-violet ]]

ask return-lime-foragers [
    wiggle
    move
    set size 6
    set color lime
    set shape "butterfly"
    set trip-lime 1
    set inside-nest-stay-time nest-stay-time
    return-to-nest
      if pcolor = white [set breed inside-nest-workers-lime ]]





ask inside-nest-workers-generalist [
    set color yellow
    move-inside-nest
    wiggle
    set shape "butterfly"
    set size 6
    set inside-nest-stay-time inside-nest-stay-time - 1
    if inside-nest-stay-time < 0
    [set breed generalist-bees
      unload-generalist ]]

ask inside-nest-workers-red [
    set color pink
    move-inside-nest
    wiggle
    set shape "butterfly"
    set size 6
    set inside-nest-stay-time inside-nest-stay-time - 1
    ifelse inside-nest-stay-time < 0
   [set breed red-foragers
      if random 100 > probability-of-constancy [ set breed generalist-bees]
      reset-times ]
    [ unload-red ]]


ask inside-nest-workers-yellow [
    set color pink
    move-inside-nest
    wiggle
    set shape "butterfly"
    set size 6
    set inside-nest-stay-time inside-nest-stay-time - 1
    ifelse inside-nest-stay-time < 0
   [set breed yellow-foragers
      if random 100 > probability-of-constancy [ set breed generalist-bees]
      reset-times ]
    [ unload-yellow ]]


ask inside-nest-workers-blue [
    set color pink
    move-inside-nest
    wiggle
    set shape "butterfly"
    set size 6
    set inside-nest-stay-time inside-nest-stay-time - 1
    ifelse inside-nest-stay-time < 0
   [set breed blue-foragers
      if random 100 > probability-of-constancy [ set breed generalist-bees]
      reset-times ]
    [ unload-blue ]]

ask inside-nest-workers-green [
    set color pink
    move-inside-nest
    wiggle
    set shape "butterfly"
    set size 6
    set inside-nest-stay-time inside-nest-stay-time - 1
    ifelse inside-nest-stay-time < 0
   [set breed green-foragers
      if random 100 > probability-of-constancy [ set breed generalist-bees]
      reset-times ]
    [ unload-green ]]

ask inside-nest-workers-pink [
    set color pink
    move-inside-nest
    wiggle
    set shape "butterfly"
    set size 6
    set inside-nest-stay-time inside-nest-stay-time - 1
    ifelse inside-nest-stay-time < 0
   [set breed pink-foragers
      if random 100 > probability-of-constancy [ set breed generalist-bees]
      reset-times ]
    [ unload-pink ]]

ask inside-nest-workers-sky [
    set color sky
    move-inside-nest
    wiggle
    set shape "butterfly"
    set size 6
    set inside-nest-stay-time inside-nest-stay-time - 1
    ifelse inside-nest-stay-time < 0
   [set breed sky-foragers
      if random 100 > probability-of-constancy [ set breed generalist-bees]
      reset-times ]
    [ unload-sky ]]

ask inside-nest-workers-cyan [
    set color cyan
    move-inside-nest
    wiggle
    set shape "butterfly"
    set size 6
    set inside-nest-stay-time inside-nest-stay-time - 1
    ifelse inside-nest-stay-time < 0
   [set breed cyan-foragers
      if random 100 > probability-of-constancy [ set breed generalist-bees]
      reset-times ]
    [ unload-cyan ]]

ask inside-nest-workers-orange [
    set color orange
    move-inside-nest
    wiggle
    set shape "butterfly"
    set size 6
    set inside-nest-stay-time inside-nest-stay-time - 1
    ifelse inside-nest-stay-time < 0
   [set breed orange-foragers
      if random 100 > probability-of-constancy [ set breed generalist-bees]
      reset-times ]
    [ unload-orange ]]

ask inside-nest-workers-brown [
    set color brown
    move-inside-nest
    wiggle
    set shape "butterfly"
    set size 6
    set inside-nest-stay-time inside-nest-stay-time - 1
    ifelse inside-nest-stay-time < 0
   [set breed brown-foragers
      if random 100 > probability-of-constancy [ set breed generalist-bees]
      reset-times ]
    [ unload-brown ]]

ask inside-nest-workers-gray [
    set color gray
    move-inside-nest
    wiggle
    set shape "butterfly"
    set size 6
    set inside-nest-stay-time inside-nest-stay-time - 1
    ifelse inside-nest-stay-time < 0
   [set breed gray-foragers
      if random 100 > probability-of-constancy [ set breed generalist-bees]
      reset-times ]
    [ unload-gray ]]

ask inside-nest-workers-violet [
    set color violet
    move-inside-nest
    wiggle
    set shape "butterfly"
    set size 6
    set inside-nest-stay-time inside-nest-stay-time - 1
    ifelse inside-nest-stay-time < 0
   [set breed violet-foragers
      if random 100 > probability-of-constancy [ set breed generalist-bees]
      reset-times ]
    [ unload-violet ]]

ask inside-nest-workers-lime [
    set color lime
    move-inside-nest
    wiggle
    set shape "butterfly"
    set size 6
    set inside-nest-stay-time inside-nest-stay-time - 1
    ifelse inside-nest-stay-time < 0
   [set breed lime-foragers
      if random 100 > probability-of-constancy [ set breed generalist-bees]
      reset-times ]
    [ unload-lime ]]




ask red-influencers [
    set color blue
    move-inside-nest
    target-green-bees
    target-sky-bees
    target-gray-bees
    target-orange-bees
    target-brown-bees
    target-cyan-bees
    target-pink-bees
    target-violet-bees
    target-lime-bees
    wiggle
    set shape "butterfly"
    set size 6
    set inside-nest-stay-time inside-nest-stay-time - 1
    ifelse inside-nest-stay-time < 0
     [ set breed red-foragers
         if random 100 > probability-of-constancy [ set breed generalist-bees]
   reset-times ]
    [ unload-red ]]



  ask yellow-influencers [                                           ;;14/12/2022
    set color blue
    move-inside-nest
    target-green-beesy
    target-sky-beesy
    target-gray-beesy
    target-orange-beesy
    target-brown-beesy
    target-cyan-beesy
    target-pink-beesy
    target-violet-beesy
    target-lime-beesy
    wiggle
    set shape "butterfly"
    set size 6
    set inside-nest-stay-time inside-nest-stay-time - 1
    ifelse inside-nest-stay-time < 0
     [ set breed yellow-foragers
         if random 100 > probability-of-constancy [ set breed generalist-bees]
   reset-times ]
    [ unload-yellow ]]


ask blue-influencers [                                           ;;14/12/2022
    set color blue
    move-inside-nest
    target-green-beesb
    target-sky-beesb
    target-gray-beesb
    target-orange-beesb
    target-brown-beesb
    target-cyan-beesb
    target-pink-beesb
    target-violet-beesb
    target-lime-beesb
    wiggle
    set shape "butterfly"
    set size 6
    set inside-nest-stay-time inside-nest-stay-time - 1
    ifelse inside-nest-stay-time < 0
     [ set breed blue-foragers
         if random 100 > probability-of-constancy [ set breed generalist-bees]
   reset-times ]
    [ unload-blue ]]


  tick
my-update-plots

end


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; behaviour programming ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to wiggle
right random 50
left random 50
end

to move
forward flight-speed
  set forager-energy forager-energy - 0              ;; before it was 0.032 as a metabolic cost
end


to move-levy-flight
  set forager-energy forager-energy - 0
  if flight-length <= 0 [
    rt random 360
    set flight-length levy levy-mu
  ]

  ifelse flight-length < flight-speed [
    fd flight-length
    set flight-length 0
  ][
    fd flight-speed
    set flight-length flight-length - flight-speed
  ]
end

to-report levy [ p-mu ]
  let result 0
  ifelse p-mu <= 1 [
    set result random-float 100000000000
  ][
    ifelse p-mu >= 3 [
      set result abs random-normal 5 1;0 1
    ][
      let a random-float 1
      set result exp ( ln (a) * (1 / 1 - p-mu))
    ]
  ]
  report result
end


to record-flower-visit
  if ticks > ticks-burn-in [
  set total-visits total-visits + flower-visits
    set flower-visits 0]
end

to record-flower-visit-red
  if ticks > ticks-burn-in [
  set total-visits-red total-visits-red + flower-visits-red
    set flower-visits-red 0]
end

to record-flower-visit-yellow
  if ticks > ticks-burn-in [
  set total-visits-yellow total-visits-yellow + flower-visits-yellow
    set flower-visits-yellow 0]
end

to record-flower-visit-blue
  if ticks > ticks-burn-in [
  set total-visits-blue total-visits-blue + flower-visits-blue
    set flower-visits-blue 0]
end

to record-flower-visit-green
  if ticks > ticks-burn-in [
  set total-visits-green total-visits-green + flower-visits-green
    set flower-visits-green 0]
end

to record-flower-visit-pink
  if ticks > ticks-burn-in [
  set total-visits-pink total-visits-pink + flower-visits-pink
    set flower-visits-pink 0]
end

to record-flower-visit-sky
  if ticks > ticks-burn-in [
  set total-visits-sky total-visits-sky + flower-visits-sky
    set flower-visits-sky 0]
end

to record-flower-visit-cyan
  if ticks > ticks-burn-in [
  set total-visits-cyan total-visits-cyan + flower-visits-cyan
    set flower-visits-cyan 0]
end

to record-flower-visit-orange
  if ticks > ticks-burn-in [
  set total-visits-orange total-visits-orange + flower-visits-orange
    set flower-visits-orange 0]
end

to record-flower-visit-brown
  if ticks > ticks-burn-in [
  set total-visits-brown total-visits-brown + flower-visits-brown
    set flower-visits-brown 0]
end

to record-flower-visit-gray
  if ticks > ticks-burn-in [
  set total-visits-gray total-visits-gray + flower-visits-gray
    set flower-visits-gray 0]
end

to record-flower-visit-violet
  if ticks > ticks-burn-in [
  set total-visits-violet total-visits-violet + flower-visits-violet
    set flower-visits-violet 0]
end

to record-flower-visit-lime
  if ticks > ticks-burn-in [
  set total-visits-lime total-visits-lime + flower-visits-lime
    set flower-visits-lime 0]
end




to eat-red-flower
  if any? red-flowers-here [
    set forager-energy forager-energy + reward-size-HQ-flowers
    set breed red-stop-foragers
    set patches-visited-per-trip patches-visited-per-trip + 1                                ;; 30/4/2021
     ]
end

to eat-yellow-flower
  if any? yellow-flowers-here [
    set forager-energy forager-energy + reward-size-HQ-flowers
    set breed yellow-stop-foragers
    set patches-visited-per-trip patches-visited-per-trip + 1                                ;; 30/4/2021
     ]
end

to eat-blue-flower
  if any? blue-flowers-here [
    set forager-energy forager-energy + reward-size-HQ-flowers
    set breed blue-stop-foragers
    set patches-visited-per-trip patches-visited-per-trip + 1                                ;; 30/4/2021
     ]
end

to eat-green-flower
  if any? green-flowers-here [
    set forager-energy forager-energy + reward-size-non-HQ-flowers
    set breed green-stop-foragers
    set patches-visited-per-trip patches-visited-per-trip + 1                                ;; 30/4/2021
     ]
end

to eat-pink-flower
  if any? pink-flowers-here [
    set forager-energy forager-energy + reward-size-non-HQ-flowers
    set breed pink-stop-foragers
    set patches-visited-per-trip patches-visited-per-trip + 1                                ;; 30/4/2021
     ]
end

to eat-sky-flower
  if any? sky-flowers-here [
    set forager-energy forager-energy + reward-size-non-HQ-flowers
    set breed sky-stop-foragers
    set patches-visited-per-trip patches-visited-per-trip + 1                                ;; 30/4/2021
     ]
end

to eat-cyan-flower
  if any? cyan-flowers-here [
    set forager-energy forager-energy + reward-size-non-HQ-flowers
    set breed cyan-stop-foragers
    set patches-visited-per-trip patches-visited-per-trip + 1                                ;; 30/4/2021
     ]
end

to eat-orange-flower
  if any? orange-flowers-here [
    set forager-energy forager-energy + reward-size-non-HQ-flowers
    set breed orange-stop-foragers
    set patches-visited-per-trip patches-visited-per-trip + 1                                ;; 30/4/2021
     ]
end

to eat-brown-flower
  if any? brown-flowers-here [
    set forager-energy forager-energy + reward-size-non-HQ-flowers
    set breed brown-stop-foragers
    set patches-visited-per-trip patches-visited-per-trip + 1                                ;; 30/4/2021
     ]
end

to eat-gray-flower
  if any? gray-flowers-here [
    set forager-energy forager-energy + reward-size-non-HQ-flowers
    set breed gray-stop-foragers
    set patches-visited-per-trip patches-visited-per-trip + 1                                ;; 30/4/2021
     ]
end

to eat-violet-flower
  if any? violet-flowers-here [
    set forager-energy forager-energy + reward-size-non-HQ-flowers
    set breed violet-stop-foragers
    set patches-visited-per-trip patches-visited-per-trip + 1                                ;; 30/4/2021
     ]
end

to eat-lime-flower
  if any? lime-flowers-here [
    set forager-energy forager-energy + reward-size-non-HQ-flowers
    set breed lime-stop-foragers
    set patches-visited-per-trip patches-visited-per-trip + 1                                ;; 30/4/2021
     ]
end


;;;;;;;;;;;;;;;;; count the number of empty flowers a bee encounters during a foraging trip

to find-empty-red-flower
  if any? empty-red-flowers-here [
    set empty-flowers-per-trip empty-flowers-per-trip + 1
  ]
end

to find-empty-green-flower
  if any? empty-green-flowers-here [
    set empty-flowers-per-trip empty-flowers-per-trip + 1
  ]
end

to find-empty-pink-flower
  if any? empty-pink-flowers-here [
    set empty-flowers-per-trip empty-flowers-per-trip + 1
  ]
end

to find-empty-blue-flower
  if any? empty-blue-flowers-here [
    set empty-flowers-per-trip empty-flowers-per-trip + 1
  ]
end

to find-empty-yellow-flower
  if any? empty-yellow-flowers-here [
    set empty-flowers-per-trip empty-flowers-per-trip + 1
  ]
end

to find-empty-sky-flower
  if any? empty-sky-flowers-here [
    set empty-flowers-per-trip empty-flowers-per-trip + 1
  ]
end

to find-empty-cyan-flower
  if any? empty-cyan-flowers-here [
    set empty-flowers-per-trip empty-flowers-per-trip + 1
  ]
end

to find-empty-orange-flower
  if any? empty-orange-flowers-here [
    set empty-flowers-per-trip empty-flowers-per-trip + 1
  ]
end

to find-empty-brown-flower
  if any? empty-brown-flowers-here [
    set empty-flowers-per-trip empty-flowers-per-trip + 1
  ]
end

to find-empty-gray-flower
  if any? empty-gray-flowers-here [
    set empty-flowers-per-trip empty-flowers-per-trip + 1
  ]
end

to find-empty-violet-flower
  if any? empty-violet-flowers-here [
    set empty-flowers-per-trip empty-flowers-per-trip + 1
  ]
end

to find-empty-lime-flower
  if any? empty-lime-flowers-here [
    set empty-flowers-per-trip empty-flowers-per-trip + 1
  ]
end


;;;;;;;;;;;;;;;;;;

to unload-generalist                                                          ;; procedure at the nest: transfer forager energy to nest
  set nest-energy nest-energy + forager-energy                     ;; turnover energy (positive and negative values possible)
  set forager-energy 0                                             ;; reset forager-energy to 0 (all energy has been transferred to nest)
  set foraging-trips-generalist-bees foraging-trips-generalist-bees + trip-generalist
  set trip-generalist 0
  set total-patches total-patches + patches-visited-per-trip        ;; 30/4/2021
  set patches-visited-per-trip 0                                   ;; 30/4/2021
  set total-empty-flowers total-empty-flowers + empty-flowers-per-trip    ;; 13/7/2022
  set empty-flowers-per-trip 0                                      ;; 13/7/2022
end

to unload-red                                                          ;; procedure at the nest: transfer forager energy to nest
  set nest-energy nest-energy + forager-energy                     ;; turnover energy (positive and negative values possible)
  set forager-energy 0                                             ;; reset forager-energy to 0 (all energy has been transferred to nest)
  set foraging-trips-red-bees foraging-trips-red-bees + trip-red
  set trip-red 0
  set total-patches total-patches + patches-visited-per-trip        ;; 30/4/2021
  set patches-visited-per-trip 0                                    ;; 30/4/2021
  set total-empty-flowers total-empty-flowers + empty-flowers-per-trip    ;; 13/7/2022
  set empty-flowers-per-trip 0                                      ;; 13/7/2022

end

to unload-yellow                                                          ;; procedure at the nest: transfer forager energy to nest
  set nest-energy nest-energy + forager-energy                     ;; turnover energy (positive and negative values possible)
  set forager-energy 0                                             ;; reset forager-energy to 0 (all energy has been transferred to nest)
  set foraging-trips-yellow-bees foraging-trips-yellow-bees + trip-yellow
  set trip-yellow 0
  set total-patches total-patches + patches-visited-per-trip        ;; 30/4/2021
  set patches-visited-per-trip 0                                    ;; 30/4/2021
  set total-empty-flowers total-empty-flowers + empty-flowers-per-trip    ;; 13/7/2022
  set empty-flowers-per-trip 0                                      ;; 13/7/2022
end

to unload-blue                                                          ;; procedure at the nest: transfer forager energy to nest
  set nest-energy nest-energy + forager-energy                     ;; turnover energy (positive and negative values possible)
  set forager-energy 0                                             ;; reset forager-energy to 0 (all energy has been transferred to nest)
  set foraging-trips-blue-bees foraging-trips-blue-bees + trip-blue
  set trip-blue 0
  set total-patches total-patches + patches-visited-per-trip        ;; 30/4/2021
  set patches-visited-per-trip 0                                    ;; 30/4/2021
  set total-empty-flowers total-empty-flowers + empty-flowers-per-trip    ;; 13/7/2022
  set empty-flowers-per-trip 0                                      ;; 13/7/2022
end

to unload-green                                                         ;; procedure at the nest: transfer forager energy to nest
  set nest-energy nest-energy + forager-energy                     ;; turnover energy (positive and negative values possible)
  set forager-energy 0                                             ;; reset forager-energy to 0 (all energy has been transferred to nest)
  set foraging-trips-green-bees foraging-trips-green-bees + trip-green
  set trip-green 0
  set total-patches total-patches + patches-visited-per-trip        ;; 30/4/2021
  set patches-visited-per-trip 0                                    ;; 30/4/2021
  set total-empty-flowers total-empty-flowers + empty-flowers-per-trip    ;; 13/7/2022
  set empty-flowers-per-trip 0                                      ;; 13/7/2022
end

to unload-pink                                                         ;; procedure at the nest: transfer forager energy to nest
  set nest-energy nest-energy + forager-energy                     ;; turnover energy (positive and negative values possible)
  set forager-energy 0                                             ;; reset forager-energy to 0 (all energy has been transferred to nest)
  set foraging-trips-pink-bees foraging-trips-pink-bees + trip-pink
  set trip-pink 0
  set total-patches total-patches + patches-visited-per-trip        ;; 30/4/2021
  set patches-visited-per-trip 0                                    ;; 30/4/2021
  set total-empty-flowers total-empty-flowers + empty-flowers-per-trip    ;; 13/7/2022
  set empty-flowers-per-trip 0                                      ;; 13/7/2022
end

to unload-sky                                                         ;; procedure at the nest: transfer forager energy to nest
  set nest-energy nest-energy + forager-energy                     ;; turnover energy (positive and negative values possible)
  set forager-energy 0                                             ;; reset forager-energy to 0 (all energy has been transferred to nest)
  set foraging-trips-sky-bees foraging-trips-sky-bees + trip-sky
  set trip-sky 0
  set total-patches total-patches + patches-visited-per-trip        ;; 30/4/2021
  set patches-visited-per-trip 0                                    ;; 30/4/2021
  set total-empty-flowers total-empty-flowers + empty-flowers-per-trip    ;; 13/7/2022
  set empty-flowers-per-trip 0                                      ;; 13/7/2022
end

to unload-cyan                                                         ;; procedure at the nest: transfer forager energy to nest
  set nest-energy nest-energy + forager-energy                     ;; turnover energy (positive and negative values possible)
  set forager-energy 0                                             ;; reset forager-energy to 0 (all energy has been transferred to nest)
  set foraging-trips-cyan-bees foraging-trips-cyan-bees + trip-cyan
  set trip-cyan 0
  set total-patches total-patches + patches-visited-per-trip        ;; 30/4/2021
  set patches-visited-per-trip 0                                    ;; 30/4/2021
  set total-empty-flowers total-empty-flowers + empty-flowers-per-trip    ;; 13/7/2022
  set empty-flowers-per-trip 0                                      ;; 13/7/2022
end

to unload-orange                                                        ;; procedure at the nest: transfer forager energy to nest
  set nest-energy nest-energy + forager-energy                     ;; turnover energy (positive and negative values possible)
  set forager-energy 0                                             ;; reset forager-energy to 0 (all energy has been transferred to nest)
  set foraging-trips-orange-bees foraging-trips-orange-bees + trip-orange
  set trip-orange 0
  set total-patches total-patches + patches-visited-per-trip        ;; 30/4/2021
  set patches-visited-per-trip 0                                    ;; 30/4/2021
  set total-empty-flowers total-empty-flowers + empty-flowers-per-trip    ;; 13/7/2022
  set empty-flowers-per-trip 0                                      ;; 13/7/2022
end

to unload-brown                                                        ;; procedure at the nest: transfer forager energy to nest
  set nest-energy nest-energy + forager-energy                     ;; turnover energy (positive and negative values possible)
  set forager-energy 0                                             ;; reset forager-energy to 0 (all energy has been transferred to nest)
  set foraging-trips-brown-bees foraging-trips-brown-bees + trip-brown
  set trip-brown 0
  set total-patches total-patches + patches-visited-per-trip        ;; 30/4/2021
  set patches-visited-per-trip 0                                    ;; 30/4/2021
  set total-empty-flowers total-empty-flowers + empty-flowers-per-trip    ;; 13/7/2022
  set empty-flowers-per-trip 0                                      ;; 13/7/2022
end

to unload-gray                                                        ;; procedure at the nest: transfer forager energy to nest
  set nest-energy nest-energy + forager-energy                     ;; turnover energy (positive and negative values possible)
  set forager-energy 0                                             ;; reset forager-energy to 0 (all energy has been transferred to nest)
  set foraging-trips-gray-bees foraging-trips-gray-bees + trip-gray
  set trip-gray 0
  set total-patches total-patches + patches-visited-per-trip        ;; 30/4/2021
  set patches-visited-per-trip 0                                    ;; 30/4/2021
  set total-empty-flowers total-empty-flowers + empty-flowers-per-trip    ;; 13/7/2022
  set empty-flowers-per-trip 0                                      ;; 13/7/2022
end

to unload-violet                                                        ;; procedure at the nest: transfer forager energy to nest
  set nest-energy nest-energy + forager-energy                     ;; turnover energy (positive and negative values possible)
  set forager-energy 0                                             ;; reset forager-energy to 0 (all energy has been transferred to nest)
  set foraging-trips-violet-bees foraging-trips-violet-bees + trip-violet
  set trip-violet 0
  set total-patches total-patches + patches-visited-per-trip        ;; 30/4/2021
  set patches-visited-per-trip 0                                    ;; 30/4/2021
  set total-empty-flowers total-empty-flowers + empty-flowers-per-trip    ;; 13/7/2022
  set empty-flowers-per-trip 0                                      ;; 13/7/2022
end


to unload-lime                                                        ;; procedure at the nest: transfer forager energy to nest
  set nest-energy nest-energy + forager-energy                     ;; turnover energy (positive and negative values possible)
  set forager-energy 0                                             ;; reset forager-energy to 0 (all energy has been transferred to nest)
  set foraging-trips-lime-bees foraging-trips-lime-bees + trip-lime
  set trip-lime 0
  set total-patches total-patches + patches-visited-per-trip        ;; 30/4/2021
  set patches-visited-per-trip 0                                    ;; 30/4/2021
  set total-empty-flowers total-empty-flowers + empty-flowers-per-trip    ;; 13/7/2022
  set empty-flowers-per-trip 0                                      ;; 13/7/2022
end

to move-inside-nest
  forward 0.1
  if pcolor = green [rt 180 ]
  ;set forager-energy forager-energy                                ;; 21/6/2021
end


;;; recruitment communication: red influencers can turn non-red agents into red foragers

to target-green-bees
  if any? inside-nest-workers-green-here [
let target one-of inside-nest-workers-green-here
ask target [ set breed red-foragers ]
]
end

to target-pink-bees
  if any? inside-nest-workers-pink-here [
let target one-of inside-nest-workers-pink-here
ask target [ set breed red-foragers ]
]
end

to target-sky-bees
  if any? inside-nest-workers-sky-here [
let target one-of inside-nest-workers-sky-here
ask target [ set breed red-foragers ]
]
end

to target-cyan-bees
  if any? inside-nest-workers-cyan-here [
let target one-of inside-nest-workers-cyan-here
ask target [ set breed red-foragers ]
]
end

to target-orange-bees
  if any? inside-nest-workers-orange-here [
let target one-of inside-nest-workers-orange-here
ask target [ set breed red-foragers ]
]
end

to target-brown-bees
  if any? inside-nest-workers-brown-here [
let target one-of inside-nest-workers-brown-here
ask target [ set breed red-foragers ]
]
end

to target-gray-bees
  if any? inside-nest-workers-gray-here [
let target one-of inside-nest-workers-gray-here
ask target [ set breed red-foragers ]
]
end

to target-violet-bees
  if any? inside-nest-workers-violet-here [
let target one-of inside-nest-workers-violet-here
ask target [ set breed red-foragers ]
]
end

to target-lime-bees
  if any? inside-nest-workers-lime-here [
let target one-of inside-nest-workers-lime-here
ask target [ set breed red-foragers ]
]
end


;;; recruitment communication: yellow influencers can turn other agents into yellow foragers


to target-green-beesy
  if any? inside-nest-workers-green-here [
let target one-of inside-nest-workers-green-here
ask target [ set breed yellow-foragers ]
]
end

to target-pink-beesy
  if any? inside-nest-workers-pink-here [
let target one-of inside-nest-workers-pink-here
ask target [ set breed yellow-foragers ]
]
end

to target-sky-beesy
  if any? inside-nest-workers-sky-here [
let target one-of inside-nest-workers-sky-here
ask target [ set breed yellow-foragers ]
]
end

to target-cyan-beesy
  if any? inside-nest-workers-cyan-here [
let target one-of inside-nest-workers-cyan-here
ask target [ set breed yellow-foragers ]
]
end

to target-orange-beesy
  if any? inside-nest-workers-orange-here [
let target one-of inside-nest-workers-orange-here
ask target [ set breed yellow-foragers ]
]
end

to target-brown-beesy
  if any? inside-nest-workers-brown-here [
let target one-of inside-nest-workers-brown-here
ask target [ set breed yellow-foragers ]
]
end

to target-gray-beesy
  if any? inside-nest-workers-gray-here [
let target one-of inside-nest-workers-gray-here
ask target [ set breed yellow-foragers ]
]
end

to target-violet-beesy
  if any? inside-nest-workers-violet-here [
let target one-of inside-nest-workers-violet-here
ask target [ set breed yellow-foragers ]
]
end

to target-lime-beesy
  if any? inside-nest-workers-lime-here [
let target one-of inside-nest-workers-lime-here
ask target [ set breed yellow-foragers ]
]
end


;;; recruitment communication: blue influencers can turn other agents into blue foragers


to target-green-beesb
  if any? inside-nest-workers-green-here [
let target one-of inside-nest-workers-green-here
ask target [ set breed blue-foragers ]
]
end

to target-pink-beesb
  if any? inside-nest-workers-pink-here [
let target one-of inside-nest-workers-pink-here
ask target [ set breed blue-foragers ]
]
end

to target-sky-beesb
  if any? inside-nest-workers-sky-here [
let target one-of inside-nest-workers-sky-here
ask target [ set breed blue-foragers ]
]
end

to target-cyan-beesb
  if any? inside-nest-workers-cyan-here [
let target one-of inside-nest-workers-cyan-here
ask target [ set breed blue-foragers ]
]
end

to target-orange-beesb
  if any? inside-nest-workers-orange-here [
let target one-of inside-nest-workers-orange-here
ask target [ set breed blue-foragers ]
]
end

to target-brown-beesb
  if any? inside-nest-workers-brown-here [
let target one-of inside-nest-workers-brown-here
ask target [ set breed blue-foragers ]
]
end

to target-gray-beesb
  if any? inside-nest-workers-gray-here [
let target one-of inside-nest-workers-gray-here
ask target [ set breed blue-foragers ]
]
end

to target-violet-beesb
  if any? inside-nest-workers-violet-here [
let target one-of inside-nest-workers-violet-here
ask target [ set breed blue-foragers ]
]
end

to target-lime-beesb
  if any? inside-nest-workers-lime-here [
let target one-of inside-nest-workers-lime-here
ask target [ set breed blue-foragers ]
]
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;; for flowers: they are emptied when visited

to be-eaten-red
  set flower-visits 1
  set flower-visits-red 1
  if any? generalist-bees-here [
    set breed empty-red-flowers
  ]
  if any? red-foragers-here [
    set breed empty-red-flowers
  ]
end

to be-eaten-yellow
  set flower-visits 1
  set flower-visits-yellow 1
  if any? generalist-bees-here [
    set breed empty-yellow-flowers
  ]
  if any? yellow-foragers-here [
    set breed empty-yellow-flowers
  ]
end

to be-eaten-blue
  set flower-visits 1
  set flower-visits-blue 1
  if any? generalist-bees-here [
    set breed empty-blue-flowers
  ]
  if any? blue-foragers-here [
    set breed empty-blue-flowers
  ]
end

to be-eaten-green
  set flower-visits 1
  set flower-visits-green 1
  if any? generalist-bees-here [
    set breed empty-green-flowers
  ]
  if any? green-foragers-here [
    set breed empty-green-flowers
  ]
end

to be-eaten-pink
  set flower-visits 1
  set flower-visits-pink 1
  if any? generalist-bees-here [
    set breed empty-pink-flowers
  ]
  if any? pink-foragers-here [
    set breed empty-pink-flowers
  ]
end

to be-eaten-sky
  set flower-visits 1
  set flower-visits-sky 1
  if any? generalist-bees-here [
    set breed empty-sky-flowers
  ]
  if any? sky-foragers-here [
    set breed empty-sky-flowers
  ]
end

to be-eaten-cyan
  set flower-visits 1
  set flower-visits-cyan 1
  if any? generalist-bees-here [
    set breed empty-cyan-flowers
  ]
  if any? cyan-foragers-here [
    set breed empty-cyan-flowers
  ]
end

to be-eaten-orange
  set flower-visits 1
  set flower-visits-orange 1
  if any? generalist-bees-here [
    set breed empty-orange-flowers
  ]
  if any? orange-foragers-here [
    set breed empty-orange-flowers
  ]
end

to be-eaten-brown
  set flower-visits 1
  set flower-visits-brown 1
  if any? generalist-bees-here [
    set breed empty-brown-flowers
  ]
  if any? brown-foragers-here [
    set breed empty-brown-flowers
  ]
end

to be-eaten-gray
  set flower-visits 1
  set flower-visits-gray 1
  if any? generalist-bees-here [
    set breed empty-gray-flowers
  ]
  if any? gray-foragers-here [
    set breed empty-gray-flowers
  ]
end

to be-eaten-violet
  set flower-visits 1
  set flower-visits-violet 1
  if any? generalist-bees-here [
    set breed empty-violet-flowers
  ]
  if any? violet-foragers-here [
    set breed empty-violet-flowers
  ]
end

to be-eaten-lime
  set flower-visits 1
  set flower-visits-lime 1
  if any? generalist-bees-here [
    set breed empty-lime-flowers
  ]
  if any? lime-foragers-here [
    set breed empty-lime-flowers
  ]
end



;;;; general bee behaviours

to return-to-nest
  let scent-ahead nest-scent-at-angle   0
  let scent-right nest-scent-at-angle  45
  let scent-left  nest-scent-at-angle -45
  if (scent-right > scent-ahead) or (scent-left > scent-ahead)
  [ ifelse scent-right > scent-left
    [ rt 45 ]
    [ lt 45 ] ]


end

to-report nest-scent-at-angle [angle]
  let p patch-right-and-ahead angle 1
  if p = nobody [ report 0 ]
  report [nest-scent] of p
end

to-report recruitment-probability
 let z exp (logisticA + (logisticB * distance-red))
 let recruit-prob z / (1 + z)
 report recruit-prob
end

to reset-times
  set inside-nest-stay-time nest-stay-time
  set empty-flower-time flower-refilling-time
end



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; plot

to my-update-plots
  set-current-plot "population"

  set-current-plot-pen "generalist-bees"
  plot count generalist-bees

  set-current-plot-pen "red-foragers"
  plot count red-foragers

  set-current-plot-pen "yellow-foragers"
  plot count yellow-foragers

  set-current-plot-pen "blue-foragers"
 plot count blue-foragers

  set-current-plot-pen "green-foragers"
  plot count green-foragers

  set-current-plot-pen "pink-foragers"
  plot count pink-foragers

  set-current-plot-pen "sky-foragers"
  plot count sky-foragers

  set-current-plot-pen "cyan-foragers"
  plot count cyan-foragers

  set-current-plot-pen "orange-foragers"
  plot count orange-foragers

  set-current-plot-pen "brown-foragers"
  plot count brown-foragers

  set-current-plot-pen "gray-foragers"
  plot count gray-foragers

  set-current-plot-pen "violet-foragers"
  plot count violet-foragers

  set-current-plot-pen "lime-foragers"
  plot count lime-foragers


  ;;;;;;;;;;;;;;;;;;;;

  set-current-plot "empty flowers"

  set-current-plot-pen "empty-red-flowers"
  plot count empty-red-flowers

  set-current-plot-pen "empty-yellow-flowers"
  plot count empty-yellow-flowers

  set-current-plot-pen "empty-blue-flowers"
  plot count empty-blue-flowers

  set-current-plot-pen "empty-green-flowers"
  plot count empty-green-flowers

  set-current-plot-pen "empty-pink-flowers"
  plot count empty-pink-flowers

  ;set-current-plot-pen "empty-sky-flowers"
  ;plot count empty-sky-flowers

 ; set-current-plot-pen "empty-cyan-flowers"
 ; plot count empty-cyan-flowers

;  set-current-plot-pen "empty-orange-flowers"
 ; plot count empty-orange-flowers

 ; set-current-plot-pen "empty-brown-flowers"
 ; plot count empty-brown-flowers

 ; set-current-plot-pen "empty-gray-flowers"
 ; plot count empty-gray-flowers

;  set-current-plot-pen "empty-violet-flowers"
;  plot count empty-violet-flowers

 ; set-current-plot-pen "empty-lime-flowers"
 ; plot count empty-lime-flowers

end
@#$#@#$#@
GRAPHICS-WINDOW
253
11
662
421
-1
-1
1.0
1
10
1
1
1
0
1
1
1
-200
200
-200
200
0
0
1
ticks
30.0

BUTTON
13
10
76
43
setup
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
82
11
157
44
go once
go
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
150
11
213
44
NIL
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SLIDER
14
87
214
120
max-flowers-per-species
max-flowers-per-species
0
1000
200.0
10
1
NIL
HORIZONTAL

SLIDER
14
52
214
85
number-of-start-bees
number-of-start-bees
1
100
10.0
1
1
NIL
HORIZONTAL

SLIDER
15
173
205
206
reward-size-HQ-flowers
reward-size-HQ-flowers
0
50
10.0
1
1
%
HORIZONTAL

SLIDER
15
209
231
242
reward-size-non-HQ-flowers
reward-size-non-HQ-flowers
0
50
10.0
1
1
%
HORIZONTAL

SLIDER
792
425
946
458
probability-of-constancy
probability-of-constancy
0
100
100.0
5
1
NIL
HORIZONTAL

SLIDER
545
424
664
457
nest-stay-time
nest-stay-time
0
1200
300.0
10
1
NIL
HORIZONTAL

PLOT
666
11
992
268
population
Time (ticks)
Population
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"red-foragers" 0.5 0 -5298144 true "" "plot count red-foragers"
"generalist-bees" 0.5 0 -16777216 true "" "plot count generalist-bees"
"yellow-foragers" 0.5 0 -1184463 true "" "plot count yellow-foragers"
"blue-foragers" 0.5 0 -13345367 true "" "plot count blue-foragers"
"green-foragers" 0.5 0 -8330359 true "" "plot count green-foragers"
"pink-foragers" 0.5 0 -7500403 true "" "plot count pink-foragers"
"sky-foragers" 0.5 0 -8275240 true "" "plot count sky-foragers"
"cyan-foragers" 0.5 0 -2674135 true "" "plot count cyan-foragers"
"orange-foragers" 0.5 0 -955883 true "" "plot count orange-foragers"
"brown-foragers" 0.5 0 -12440034 true "" "plot count brown-foragers"
"gray-foragers" 0.5 0 -7500403 true "" "plot count gray-foragers"
"violet-foragers" 0.5 0 -11783835 true "" "plot count violet-foragers"
"lime-foragers" 0.5 0 -11085214 true "" "plot count lime-foragers"

SLIDER
417
424
536
457
flower-refilling-time
flower-refilling-time
0
3600
0.0
100
1
NIL
HORIZONTAL

SLIDER
14
123
214
156
crop-capacity
crop-capacity
0
99.99
99.999
0.01
1
%
HORIZONTAL

SLIDER
792
457
946
490
within-trip-constancy
within-trip-constancy
0
100
0.0
5
1
NIL
HORIZONTAL

SLIDER
793
492
946
525
flower-stay-timer
flower-stay-timer
0
600
600.0
5
1
NIL
HORIZONTAL

SLIDER
262
424
407
457
recruitment-is-1
recruitment-is-1
1
100000001
1.00000001E8
100000000
1
NIL
HORIZONTAL

SLIDER
997
12
1103
45
ticks-burn-in
ticks-burn-in
0
10000
3600.0
100
1
NIL
HORIZONTAL

PLOT
666
271
829
421
Patches per trip
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 0 -4079321 true "" "plot total-patches / (0.01 + foraging-trips-lime-bees + foraging-trips-violet-bees + foraging-trips-gray-bees + foraging-trips-brown-bees + foraging-trips-orange-bees + foraging-trips-cyan-bees + foraging-trips-sky-bees + foraging-trips-pink-bees + foraging-trips-green-bees + foraging-trips-blue-bees + foraging-trips-red-bees + foraging-trips-yellow-bees + foraging-trips-generalist-bees)"

SLIDER
682
425
787
458
levy-mu
levy-mu
0
3
1.8
0.1
1
NIL
HORIZONTAL

PLOT
833
271
993
421
Empty flowers per trip
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 0 -14070903 true "" "plot total-empty-flowers / (0.01 + foraging-trips-lime-bees + foraging-trips-violet-bees + foraging-trips-gray-bees + foraging-trips-brown-bees + foraging-trips-orange-bees + foraging-trips-cyan-bees + foraging-trips-sky-bees + foraging-trips-pink-bees + foraging-trips-green-bees + foraging-trips-blue-bees + foraging-trips-red-bees + foraging-trips-yellow-bees + foraging-trips-generalist-bees)"

MONITOR
22
299
103
344
yellow flowers
count yellow-flowers
17
1
11

MONITOR
22
246
104
295
red flowers
count red-flowers
17
1
12

MONITOR
24
350
104
395
blue flowers
count blue-flowers
17
1
11

MONITOR
24
400
104
445
green flowers
count green-flowers
17
1
11

MONITOR
119
246
226
295
red flower visits
total-visits-red
17
1
12

MONITOR
119
299
225
344
yellow flower visits
total-visits-yellow
17
1
11

MONITOR
119
350
225
395
blue flower visits
total-visits-blue
17
1
11

MONITOR
119
399
224
444
green flower visits
total-visits-green
17
1
11

MONITOR
25
447
104
492
pink flowers
count pink-flowers
17
1
11

MONITOR
119
449
224
494
pink flowers visits
total-visits-pink
17
1
11

MONITOR
27
497
102
542
sky flowers
count sky-flowers
17
1
11

MONITOR
119
497
223
542
sky flower visits
total-visits-sky
17
1
11

MONITOR
27
546
102
591
cyan flowers
count cyan-flowers
17
1
11

MONITOR
118
547
222
592
cyan flower visits
total-visits-cyan
17
1
11

MONITOR
27
595
102
640
orange flowers
count orange-flowers
17
1
11

MONITOR
117
596
222
641
orange flower visits
total-visits-orange
17
1
11

MONITOR
27
643
102
688
brown flowers
count brown-flowers
17
1
11

MONITOR
116
644
222
689
brown flower visits
total-visits-brown
17
1
11

MONITOR
28
692
102
737
gray flowers
count gray-flowers
17
1
11

MONITOR
116
693
222
738
gray flower visits
total-visits-gray
17
1
11

MONITOR
29
742
102
787
violet flowers
count violet-flowers
17
1
11

MONITOR
116
743
222
788
violet flower visits
total-visits-violet
17
1
11

MONITOR
30
791
102
836
lime flowers
count lime-flowers
17
1
11

MONITOR
116
792
221
837
lime flower visits
total-visits-lime
17
1
11

SLIDER
682
462
787
495
flight-speed
flight-speed
0
2
1.0
0.1
1
NIL
HORIZONTAL

PLOT
241
463
578
649
empty flowers
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"empty-red-flowers" 1.0 0 -3844592 true "" "plot count empty-red-flowers"
"empty-yellow-flowers" 1.0 0 -1184463 true "" "plot count empty-yellow-flowers"
"empty-blue-flowers" 1.0 0 -13345367 true "" "plot count empty-blue-flowers"
"empty-green-flowers" 1.0 0 -13840069 true "" "plot count empty-green-flowers"
"empty-pink-flowers" 1.0 0 -2064490 true "" "plot count empty-pink-flowers"

PLOT
585
499
785
649
total empty flowers
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 0 -5825686 true "" "plot count (turtle-set \n  empty-red-flowers\n  empty-yellow-flowers\n  empty-blue-flowers\n  empty-green-flowers\n  empty-pink-flowers\n  empty-sky-flowers\n  empty-cyan-flowers\n  empty-orange-flowers\n  empty-brown-flowers\n  empty-gray-flowers\n  empty-violet-flowers\n  empty-lime-flowers)"

@#$#@#$#@
## WHAT IS IT?

(a general understanding of what the model is trying to show or explain)

## HOW IT WORKS

(what rules the agents use to create the overall behavior of the model)

## HOW TO USE IT

(how to use the model, including a description of each of the items in the Interface tab)

## THINGS TO NOTICE

(suggested things for the user to notice while running the model)

## THINGS TO TRY

(suggested things for the user to try to do (move sliders, switches, etc.) with the model)

## EXTENDING THE MODEL

(suggested things to add or change in the Code tab to make the model more complicated, detailed, accurate, etc.)

## NETLOGO FEATURES

(interesting or unusual features of NetLogo that the model uses, particularly in the Code tab; or where workarounds were needed for missing features)

## RELATED MODELS

(models in the NetLogo Models Library and elsewhere which are of related interest)

## CREDITS AND REFERENCES

(a reference to the model's URL on the web if it has one, as well as any other necessary credits, citations, and links)
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
15
Circle -1 true true 203 65 88
Circle -1 true true 70 65 162
Circle -1 true true 150 105 120
Polygon -7500403 true false 218 120 240 165 255 165 278 120
Circle -7500403 true false 214 72 67
Rectangle -1 true true 164 223 179 298
Polygon -1 true true 45 285 30 285 30 240 15 195 45 210
Circle -1 true true 3 83 150
Rectangle -1 true true 65 221 80 296
Polygon -1 true true 195 285 210 285 210 240 240 210 195 210
Polygon -7500403 true false 276 85 285 105 302 99 294 83
Polygon -7500403 true false 219 85 210 105 193 99 201 83

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

wolf
false
0
Polygon -16777216 true false 253 133 245 131 245 133
Polygon -7500403 true true 2 194 13 197 30 191 38 193 38 205 20 226 20 257 27 265 38 266 40 260 31 253 31 230 60 206 68 198 75 209 66 228 65 243 82 261 84 268 100 267 103 261 77 239 79 231 100 207 98 196 119 201 143 202 160 195 166 210 172 213 173 238 167 251 160 248 154 265 169 264 178 247 186 240 198 260 200 271 217 271 219 262 207 258 195 230 192 198 210 184 227 164 242 144 259 145 284 151 277 141 293 140 299 134 297 127 273 119 270 105
Polygon -7500403 true true -1 195 14 180 36 166 40 153 53 140 82 131 134 133 159 126 188 115 227 108 236 102 238 98 268 86 269 92 281 87 269 103 269 113

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270
@#$#@#$#@
NetLogo 6.1.1
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
<experiments>
  <experiment name="Test" repetitions="30" sequentialRunOrder="false" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <timeLimit steps="36000"/>
    <metric>total-visits-red</metric>
    <metric>total-visits-yellow</metric>
    <metric>total-visits-blue</metric>
    <metric>total-visits-green</metric>
    <metric>total-visits-pink</metric>
    <metric>total-visits-sky</metric>
    <metric>total-visits-cyan</metric>
    <metric>total-visits-orange</metric>
    <metric>total-visits-brown</metric>
    <metric>total-visits-gray</metric>
    <metric>total-visits-violet</metric>
    <metric>total-visits-lime</metric>
    <metric>total-empty-flowers / (0.01 + foraging-trips-lime-bees + foraging-trips-violet-bees + foraging-trips-gray-bees + foraging-trips-brown-bees + foraging-trips-orange-bees + foraging-trips-cyan-bees + foraging-trips-sky-bees + foraging-trips-pink-bees + foraging-trips-green-bees + foraging-trips-blue-bees + foraging-trips-red-bees + foraging-trips-yellow-bees + foraging-trips-generalist-bees)</metric>
    <enumeratedValueSet variable="flower-refilling-time">
      <value value="0"/>
      <value value="1200"/>
      <value value="3600"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="reward-size-red-flowers">
      <value value="10"/>
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="reward-size-non-red-flowers">
      <value value="10"/>
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number-of-start-bees">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="probability-of-constancy">
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="within-trip-constancy">
      <value value="0"/>
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="nest-stay-time">
      <value value="300"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="crop-capacity">
      <value value="99.999"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="flower-stay-timer">
      <value value="600"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="max-flowers-per-species">
      <value value="50"/>
      <value value="500"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="recruitment-is-1">
      <value value="100000001"/>
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ticks-burn-in">
      <value value="7200"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="levy-mu">
      <value value="1.4"/>
      <value value="2.4"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="Test new" repetitions="30" sequentialRunOrder="false" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <timeLimit steps="36000"/>
    <metric>total-visits-red</metric>
    <metric>total-visits-yellow</metric>
    <metric>total-visits-blue</metric>
    <metric>total-visits-green</metric>
    <metric>total-visits-pink</metric>
    <metric>total-visits-sky</metric>
    <metric>total-visits-cyan</metric>
    <metric>total-visits-orange</metric>
    <metric>total-visits-brown</metric>
    <metric>total-visits-gray</metric>
    <metric>total-visits-violet</metric>
    <metric>total-visits-lime</metric>
    <metric>total-empty-flowers / (0.01 + foraging-trips-lime-bees + foraging-trips-violet-bees + foraging-trips-gray-bees + foraging-trips-brown-bees + foraging-trips-orange-bees + foraging-trips-cyan-bees + foraging-trips-sky-bees + foraging-trips-pink-bees + foraging-trips-green-bees + foraging-trips-blue-bees + foraging-trips-red-bees + foraging-trips-yellow-bees + foraging-trips-generalist-bees)</metric>
    <enumeratedValueSet variable="flower-refilling-time">
      <value value="0"/>
      <value value="1200"/>
      <value value="3600"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="reward-size-red-flowers">
      <value value="10"/>
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="reward-size-non-red-flowers">
      <value value="10"/>
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number-of-start-bees">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="probability-of-constancy">
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="within-trip-constancy">
      <value value="0"/>
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="nest-stay-time">
      <value value="300"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="crop-capacity">
      <value value="99.999"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="flower-stay-timer">
      <value value="600"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="max-flowers-per-species">
      <value value="100"/>
      <value value="1000"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="recruitment-is-1">
      <value value="100000001"/>
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ticks-burn-in">
      <value value="3600"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="levy-mu">
      <value value="1.8"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="Colony size small rewards" repetitions="10" sequentialRunOrder="false" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <timeLimit steps="36000"/>
    <metric>total-visits-red</metric>
    <metric>total-visits-yellow</metric>
    <metric>total-visits-blue</metric>
    <metric>total-visits-green</metric>
    <metric>total-visits-pink</metric>
    <metric>total-visits-sky</metric>
    <metric>total-visits-cyan</metric>
    <metric>total-visits-orange</metric>
    <metric>total-visits-brown</metric>
    <metric>total-visits-gray</metric>
    <metric>total-visits-violet</metric>
    <metric>total-visits-lime</metric>
    <metric>total-empty-flowers / (0.01 + foraging-trips-lime-bees + foraging-trips-violet-bees + foraging-trips-gray-bees + foraging-trips-brown-bees + foraging-trips-orange-bees + foraging-trips-cyan-bees + foraging-trips-sky-bees + foraging-trips-pink-bees + foraging-trips-green-bees + foraging-trips-blue-bees + foraging-trips-red-bees + foraging-trips-yellow-bees + foraging-trips-generalist-bees)</metric>
    <enumeratedValueSet variable="flower-refilling-time">
      <value value="0"/>
      <value value="1200"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="reward-size-HQ-flowers">
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="reward-size-non-HQ-flowers">
      <value value="10"/>
    </enumeratedValueSet>
    <steppedValueSet variable="number-of-start-bees" first="10" step="20" last="300"/>
    <enumeratedValueSet variable="probability-of-constancy">
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="within-trip-constancy">
      <value value="0"/>
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="nest-stay-time">
      <value value="300"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="crop-capacity">
      <value value="99.999"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="flower-stay-timer">
      <value value="600"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="max-flowers-per-species">
      <value value="200"/>
      <value value="2000"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="recruitment-is-1">
      <value value="100000001"/>
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ticks-burn-in">
      <value value="3600"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="levy-mu">
      <value value="1.8"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="Test 3HQ" repetitions="30" sequentialRunOrder="false" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <timeLimit steps="36000"/>
    <metric>total-visits-red</metric>
    <metric>total-visits-yellow</metric>
    <metric>total-visits-blue</metric>
    <metric>total-visits-green</metric>
    <metric>total-visits-pink</metric>
    <metric>total-visits-sky</metric>
    <metric>total-visits-cyan</metric>
    <metric>total-visits-orange</metric>
    <metric>total-visits-brown</metric>
    <metric>total-visits-gray</metric>
    <metric>total-visits-violet</metric>
    <metric>total-visits-lime</metric>
    <metric>total-empty-flowers / (0.01 + foraging-trips-lime-bees + foraging-trips-violet-bees + foraging-trips-gray-bees + foraging-trips-brown-bees + foraging-trips-orange-bees + foraging-trips-cyan-bees + foraging-trips-sky-bees + foraging-trips-pink-bees + foraging-trips-green-bees + foraging-trips-blue-bees + foraging-trips-red-bees + foraging-trips-yellow-bees + foraging-trips-generalist-bees)</metric>
    <enumeratedValueSet variable="flower-refilling-time">
      <value value="0"/>
      <value value="1200"/>
      <value value="3600"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="reward-size-HQ-flowers">
      <value value="10"/>
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="reward-size-non-HQ-flowers">
      <value value="10"/>
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number-of-start-bees">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="probability-of-constancy">
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="within-trip-constancy">
      <value value="0"/>
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="nest-stay-time">
      <value value="300"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="crop-capacity">
      <value value="99.999"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="flower-stay-timer">
      <value value="600"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="max-flowers-per-species">
      <value value="200"/>
      <value value="2000"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="recruitment-is-1">
      <value value="100000001"/>
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ticks-burn-in">
      <value value="3600"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="levy-mu">
      <value value="1.8"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="Colony size large rewards" repetitions="10" sequentialRunOrder="false" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <timeLimit steps="36000"/>
    <metric>total-visits-red</metric>
    <metric>total-visits-yellow</metric>
    <metric>total-visits-blue</metric>
    <metric>total-visits-green</metric>
    <metric>total-visits-pink</metric>
    <metric>total-visits-sky</metric>
    <metric>total-visits-cyan</metric>
    <metric>total-visits-orange</metric>
    <metric>total-visits-brown</metric>
    <metric>total-visits-gray</metric>
    <metric>total-visits-violet</metric>
    <metric>total-visits-lime</metric>
    <metric>total-empty-flowers / (0.01 + foraging-trips-lime-bees + foraging-trips-violet-bees + foraging-trips-gray-bees + foraging-trips-brown-bees + foraging-trips-orange-bees + foraging-trips-cyan-bees + foraging-trips-sky-bees + foraging-trips-pink-bees + foraging-trips-green-bees + foraging-trips-blue-bees + foraging-trips-red-bees + foraging-trips-yellow-bees + foraging-trips-generalist-bees)</metric>
    <enumeratedValueSet variable="flower-refilling-time">
      <value value="0"/>
      <value value="1200"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="reward-size-HQ-flowers">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="reward-size-non-HQ-flowers">
      <value value="50"/>
    </enumeratedValueSet>
    <steppedValueSet variable="number-of-start-bees" first="10" step="20" last="300"/>
    <enumeratedValueSet variable="probability-of-constancy">
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="within-trip-constancy">
      <value value="0"/>
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="nest-stay-time">
      <value value="300"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="crop-capacity">
      <value value="99.999"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="flower-stay-timer">
      <value value="600"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="max-flowers-per-species">
      <value value="200"/>
      <value value="2000"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="recruitment-is-1">
      <value value="100000001"/>
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ticks-burn-in">
      <value value="3600"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="levy-mu">
      <value value="1.8"/>
    </enumeratedValueSet>
  </experiment>
</experiments>
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180
@#$#@#$#@
0
@#$#@#$#@
